//
//  PaywallViewControllerAPI.swift
//  SwiftAPITester
//
//  Created by Nacho Soto on 8/1/23.
//

import RevenueCat
import RevenueCatUI
import SwiftUI

@available(iOS 15.0, macOS 12.0, tvOS 15.0, *)
func paywallViewControllerAPI(_ delegate: Delegate, _ offering: Offering?) {
    let fontProvider: PaywallFontProvider = CustomPaywallFontProvider(fontName: "test")

    let controller = PaywallViewController()
    controller.delegate = delegate

    let _: UIViewController = PaywallViewController(fonts: fontProvider)
    let _: UIViewController = PaywallViewController(offering: offering)
    let _: UIViewController = PaywallViewController(offeringIdentifier: "offering")
    let _: UIViewController = PaywallViewController(displayCloseButton: true)
    let _: UIViewController = PaywallViewController(fonts: fontProvider)
    let _: UIViewController = PaywallViewController(offering: offering, displayCloseButton: true)
    let _: UIViewController = PaywallViewController(offering: offering, fonts: fontProvider)
    let _: UIViewController = PaywallViewController(offering: offering,
                                                    fonts: fontProvider,
                                                    displayCloseButton: true)
    let _: UIViewController = PaywallViewController(offeringIdentifier: "offering", displayCloseButton: true)
    let _: UIViewController = PaywallViewController(offeringIdentifier: "offering", fonts: fontProvider)
    let _: UIViewController = PaywallViewController(offeringIdentifier: "offering",
                                                    fonts: fontProvider,
                                                    displayCloseButton: true)

    controller.update(with: offering!)
    controller.update(with: "offering_identifier")
}

@available(iOS 15.0, macOS 12.0, tvOS 15.0, *)
func paywallFooterViewControllerAPI(_ delegate: Delegate, _ offering: Offering?) {
    let controller = PaywallFooterViewController()
    controller.delegate = delegate

    let _: UIViewController = PaywallFooterViewController(offering: offering)
    let _: UIViewController = PaywallFooterViewController(offeringIdentifier: "offering")
}

@available(iOS 15.0, macOS 12.0, tvOS 15.0, *)
final class Delegate: PaywallViewControllerDelegate {

    func paywallViewController(_ controller: PaywallViewController,
                               didFinishPurchasingWith customerInfo: CustomerInfo) {}

    func paywallViewController(_ controller: PaywallViewController,
                               didFinishPurchasingWith customerInfo: CustomerInfo,
                               transaction: StoreTransaction?) {}

    func paywallViewControllerDidCancelPurchase(_ controller: PaywallViewController) {}

    func paywallViewController(_ controller: PaywallViewController,
                               didFailPurchasingWith error: NSError) {}

    func paywallViewController(_ controller: PaywallViewController,
                               didFinishRestoringWith customerInfo: CustomerInfo) {}

    func paywallViewController(_ controller: PaywallViewController,
                               didFailRestoringWith error: NSError) {}

    func paywallViewControllerWasDismissed(_ controller: PaywallViewController) {}

    func paywallViewController(_ controller: PaywallViewController,
                               didChangeSizeTo size: CGSize) {}

}

@available(iOS 15.0, macOS 12.0, tvOS 15.0, *)
final class DelegateWithNoImplementations: PaywallViewControllerDelegate {}
